<template>
  <q-page class="q-ma-xl">
    <h1 class="text-h4">Task Tracker</h1>

    <q-form
      ref="formContainer"
      @submit.prevent="
        !selectedRow.id || !form.title ? addTodo() : updateTodo()
      "
      class="q-mb-md"
    >
      <div style="gap: 1rem" class="row items-center">
        <q-input
          ref="formField"
          class="col-6"
          filled
          dense
          v-model="form.title"
          label="Input Field"
          lazy-rules
          clearable
          :rules="[(val) => !!val || 'Field is required']"
        />
        <q-btn
          :loading="btnLoadingState"
          type="submit"
          :label="!selectedRow.id ? 'Submit' : 'Update'"
          color="primary"
          class="self-start"
        />
        <q-btn
          :loading="deleteBtnLoadingState"
          v-if="selectedRow.id"
          @click="deleteTodo()"
          class="self-start"
          label="Delete"
          color="negative"
        />

        <q-btn
          :loading="markAsDoneBtnLoadingState"
          v-if="selectedRow.id && !selectedRow.completed"
          @click="markAsDone()"
          class="self-start"
          label="Mark As Done"
          color="positive"
        />
      </div>
    </q-form>
    <q-table
      :rows="rows"
      :columns="columns"
      row-key="id"
      @row-click="onRowClick"
    />
  </q-page>

  <q-dialog v-model="isAdding">
    <q-card>
      <q-card-section>
        <div class="text-h6 text-green-10">Alert</div>
      </q-card-section>

      <q-card-section class="q-pt-none success">
        Task successfully added!
      </q-card-section>

      <q-card-actions align="right">
        <q-btn flat label="OK" color="primary" v-close-popup />
      </q-card-actions>
    </q-card>
  </q-dialog>

  <q-dialog v-model="isUpdating">
    <q-card>
      <q-card-section>
        <div class="text-h6 text-blue-10">Alert</div>
      </q-card-section>

      <q-card-section class="q-pt-none success">
        Task successfully updated!
      </q-card-section>

      <q-card-actions align="right">
        <q-btn flat label="OK" color="primary" v-close-popup />
      </q-card-actions>
    </q-card>
  </q-dialog>

  <q-dialog v-model="isDeleting">
    <q-card>
      <q-card-section>
        <div class="text-h6 text-red-10">Alert</div>
      </q-card-section>

      <q-card-section class="q-pt-none success">
        Task successfully deleted!
      </q-card-section>

      <q-card-actions align="right">
        <q-btn flat label="OK" color="primary" v-close-popup />
      </q-card-actions>
    </q-card>
  </q-dialog>

  <q-dialog v-model="isError">
    <q-card>
      <q-card-section>
        <div class="text-h6 text-red-10">Ooops! What's happening?</div>
      </q-card-section>

      <q-card-section class="q-pt-none success">
        Something is wrong. Please try again.
      </q-card-section>

      <q-card-actions align="right">
        <q-btn flat label="OK" color="primary" v-close-popup />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
import axios from "axios";

import { ref, watch } from "vue";

export default {
  setup() {
    /** -------------------------------- PROPERTIES -------------------------------- */
    let rows = ref([]);
    let columns = ref([
      {
        name: "title",
        label: "Title",
        align: "left",
        field: "title",
        headerStyle:
          "font-size: 1.5rem; background-color: #181818; color: #fff",
        style: "font-size: 1rem;",
      },
      {
        name: "completed",
        label: "Status",
        align: "left",
        field: (row) => (row.completed ? "Completed" : "Pending"),
        style: (row) =>
          row.completed
            ? "font-size: 1.2rem; background-color: #3FE17A; color: #171717; font-weight: medium; font-family: 'Poppins', sans-serif; "
            : "font-size: 1.2rem; background-color: #D3392C; color: #171717; font-weight: medium; font-family: 'Poppins', sans-serif;",
        headerStyle:
          "font-size: 1.5rem; background-color: #0F3175; color: #fff",
      },
    ]);

    let form = ref({
      userId: 1,
      title: null,
      completed: false,
    });
    let formContainer = ref(null);
    let formField = ref(null);
    let alert = ref(false);

    let isAdding = ref(false);
    let isUpdating = ref(false);
    let isDeleting = ref(false);
    let isError = ref(false);

    let markAsDoneBtnLoadingState = ref(false);
    let btnLoadingState = ref(false);
    let selectedRow = ref({});
    let deleteBtnLoadingState = ref(false);
    /** -------------------------------- END OF PROPERTIES -------------------------------- */

    /** Watches the form.value if it is empty.
     * The reason for that is because if the user wants to
     * update and clears the input field, the buttons of update,
     * delte, and mark as done still be visible. So we need
     * to reset it to avoid to cause any bugs.
     */
    watch(form.value, (newValue, oldValue) => {
      if (!newValue.title) {
        selectedRow.value = {};
      }
    });

    /** -------------------------------- AXIOS APP MAIN FUNCTIONS -------------------------------- */

    /**
     * function onRowClick(evt, row)
     *
     * @description
     * - selects a single row for updating or deletion.
     */
    const onRowClick = (evt, row) => {
      selectedRow.value = row;
      form.value.title = row.title;
    };

    /**
     * function getTodos()
     *
     * @description
     * - A function that gets all the toodos
     */
    const getTodos = () => {
      axios
        .get("https://jsonplaceholder.typicode.com/todos")
        .then((_res) => (rows.value = _res.data));
    };

    /**
     * function addTodo()
     *
     * @description
     * - A function that adds a single task.
     */
    const addTodo = () => {
      btnLoadingState.value = true;
      axios
        .post("https://jsonplaceholder.typicode.com/todos", form.value)
        .then((response) => {
          if (response.status === 201) {
            rows.value.unshift(response.data); // appends from the start of the array

            form.value.title = null;
          }
          btnLoadingState.value = false;
          formContainer.value.reset();
          formField.value.focus();
          isAdding.value = true;
        })
        .catch((error) => {
          btnLoadingState.value = false;
          formContainer.value.reset();
          formField.value.focus();
          isError.value = true;
        });
    };

    /**
     * function updateTodo()
     *
     * @description
     * - A function that updates a selected to-do.
     */
    const updateTodo = () => {
      btnLoadingState.value = true;

      axios
        .put(
          `https://jsonplaceholder.typicode.com/todos/${selectedRow.value.id}`,
          {
            title: form.value.title,
          }
        )
        .then((response) => {
          if (response.status === 200) {
            let index = rows.value.findIndex(
              (row) => row.id === selectedRow.value.id
            );
            rows.value[index].title = response.data.title;
            form.value.title = null;
            selectedRow.value = {};
          }
          btnLoadingState.value = false;
          formContainer.value.reset();
          formField.value.focus();
          isUpdating.value = true;
        })
        .catch((error) => {
          btnLoadingState.value = false;
          formContainer.value.reset();
          formField.value.focus();
          isError.value = true;
        });
    };

    /**
     * function deleteTodo()
     *
     * @description
     * - A function that deletes a selected todo.
     */
    const deleteTodo = () => {
      deleteBtnLoadingState.value = true;
      axios
        .delete(
          `https://jsonplaceholder.typicode.com/todos/${selectedRow.value.id}`
        )
        .then((response) => {
          if (response.status === 200) {
            rows.value = rows.value.filter(
              (row) => row.id !== selectedRow.value.id
            );
            form.value.title = null;
            selectedRow.value = {};
          }

          deleteBtnLoadingState.value = false;
          formContainer.value.reset();
          formField.value.focus();
          isDeleting.value = true;
        })
        .catch((error) => {
          deleteBtnLoadingState.value = false;
          formContainer.value.reset();
          formField.value.focus();
          isError.value = true;
        });
    };

    /**
     * function markAsDone()
     *
     * @description
     * - A function that sets the task as done. If the status is already completed, it is not valid to alter the task.
     */
    let markAsDone = () => {
      markAsDoneBtnLoadingState.value = true;

      axios
        .put(
          `https://jsonplaceholder.typicode.com/todos/${selectedRow.value.id}`
        )
        .then((response) => {
          if (response.status === 200) {
            rows.value = rows.value.map((task) => {
              if (task.id === selectedRow.value.id) {
                // Spread operator to only modify the 'completed' property.
                return { ...task, completed: true };
              }

              return task;
            });

            form.value.title = null;
            selectedRow.value = {};
          }

          // Reset all the necessary fields.
          markAsDoneBtnLoadingState.value = false;
          formContainer.value.reset();
          formField.value.focus();
          isUpdating.value = true;
        })

        /** This will get executed if there's an INTERNAL ERROR */
        .catch((error) => {
          markAsDoneBtnLoadingState.value = false;
          formContainer.value.reset();
          formField.value.focus();
          isError.value = true;
        });
    };

    getTodos(); // For the first render, get all the tasks/todos

    return {
      alert,
      rows,
      columns,
      form,
      btnLoadingState,
      addTodo,
      selectedRow,
      onRowClick,
      updateTodo,
      formContainer,
      formField,
      deleteBtnLoadingState,
      markAsDoneBtnLoadingState,
      markAsDone,
      deleteTodo,
      isAdding,
      isDeleting,
      isUpdating,
      isError,
    };
  },
};
</script>

<style lang="scss">
.confirmation-dialog {
  max-width: 35rem;
  width: 100%;
}
</style>
